FAQ Search Today's Posts Mark Forums Read
» Video Reviews

» Linux Archive

Linux-archive is a website aiming to archive linux email lists and to make them easily accessible for linux users/developers.


» Sponsor

» Partners

» Sponsor

Go Back   Linux Archive > ArchLinux > ArchLinux Pacman Development

 
 
LinkBack Thread Tools
 
Old 11-17-2011, 12:19 AM
Eric Bélanger
 
Default pacsysclean: Add new contrib script

On Wed, Nov 16, 2011 at 12:04 AM, Dan McGee <dpmcgee@gmail.com> wrote:
> On Tue, Oct 25, 2011 at 4:50 PM, Eric Bélanger <snowmaniscool@gmail.com> wrote:
>> No. I was waiting for feedback for the new version that I appended at
>> the end of my last email. Allan was supposed to give it a look but I
>> guess he was too busy with the pacman 4 release like everyone else. If
>> that version is OK, let me know and I'll resubmit an updated git
>> patch.
>
> Looked at this tonight. A few observations:
>
> * We use 'KiB' instead of 'K' now, so the magic matching was busted

Yeah, I haven't looked at it since pacman 4 is out.

> * running one `pacman -Qi` call and one awk invocation per package
> really stinks and is very slow
>

Thanks for fixing and improving it. There's only a minor change to do
(see inline script) and the rest is fine with me. I noticed that you
changed the sorting order but I could add an option for that later
once it's pushed to master or maint. I'll wait a few days in case
there are other people who wants to comment, then I'll submit that
version in a proper git patch.

>
> A revised version is below that pipelines and reduces calls to all
> programs involved. It takes 1.8 seconds now instead of a lot longer.
> (you can make it go faster, 0.5 seconds total, if you add a single
> grep call in the pipeline, but not too concerned at this point).
>
> Dave, I hope you cry at my bash skillz.
>
> -Dan
>
>
> $ time bash pacsysclean.sh >/dev/null
>
> real * *0m1.862s
> user * *0m1.803s
> sys * * 0m0.070s
>
>
> #!/bin/bash
>
> PACMAN_OPTS=
>
> usage() {
> * * * *echo "pacsysclean - Sort installed packages by decreasing installed size."
> * * * *echo
> * * * *echo "Usage: pacsysclean [options]"
> * * * *echo
> * * * *echo "Options:"
> * * * *echo " *-o <options> * * Specify custom pacman query options (e.g., -dt)"

replace by:

echo " -o <options> Specify custom pacman query options (e.g., dt)"

as "pacsysclean -o -dt" doesn't work.


> * * * *echo " *-h, --help * * * Show this help message and exit"
> }
>
>
> if [ -n "$1" ]; then
> * * * *case "$1" in
> * * * * * * * *-o) PACMAN_OPTS="${2}" ;;
> * * * * * * * *-h|--help) usage; exit 0 ;;
> * * * * * * * **) usage; exit 1 ;;
> * * * *esac
> fi
>
> IFS=$'
'
> name="^Name.*: (.*)$"
> size="^Installed Size.*: (.*) KiB$"
> for line in $(LANG=C pacman -Qi $PACMAN_OPTS); do
> * * * *if [[ $line =~ $name ]]; then
> * * * * * * * *printf "%s " ${BASH_REMATCH[1]}
> * * * *elif [[ $line =~ $size ]]; then
> * * * * * * * *printf "%s
" ${BASH_REMATCH[1]}
> * * * *fi
> done | sort -g -k2 | awk '
> BEGIN {
> * * * *split("KiB MiB GiB TiB PiB EiB ZiB YiB", suffix)
> }
> function format_size(size) {
> * * * *count = 1
> * * * *while (size + 0 > 1024) {
> * * * * * * * *size /= 1024
> * * * * * * * *count++
> * * * *}
> * * * *sizestr = sprintf("%.2f %s", size, suffix[count])
> * * * *return sizestr
> }
> {
> * * * *printf("%s %s
", format_size($2), $1);
> }'
>
>
 
Old 11-21-2011, 09:21 PM
Eric Bélanger
 
Default pacsysclean: Add new contrib script

pacsysclean sort installed packages by decreasing installed size. It's
useful for finding large unused package when doing system clean-up. This
script is an improved version of other similar scripts posted on the
forums. Thanks goes to Dan for fixing and improving my original script.

Signed-off-by: Eric Bélanger <snowmaniscool@gmail.com>

---
---
contrib/.gitignore | 1 +
contrib/Makefile.am | 5 +++-
contrib/pacsysclean.in | 50 ++++++++++++++++++++++++++++++++++++++++++++++++
3 files changed, 55 insertions(+), 1 deletions(-)
create mode 100755 contrib/pacsysclean.in

diff --git a/contrib/.gitignore b/contrib/.gitignore
index 1bd145f..19b81e0 100644
--- a/contrib/.gitignore
+++ b/contrib/.gitignore
@@ -6,5 +6,6 @@ paclist
paclog-pkglist
pacscripts
pacsearch
+pacsysclean
wget-xdelta.sh
zsh_completion
diff --git a/contrib/Makefile.am b/contrib/Makefile.am
index be0a4ba..0ff1d9d 100644
--- a/contrib/Makefile.am
+++ b/contrib/Makefile.am
@@ -5,7 +5,8 @@ OURSCRIPTS =
paclist
paclog-pkglist
pacscripts
- pacsearch
+ pacsearch
+ pacsysclean

OURFILES =
bash_completion
@@ -21,6 +22,7 @@ EXTRA_DIST =
paclist.in
pacscripts.in
pacsearch.in
+ pacsysclean.in
vimprojects
zsh_completion.in
README
@@ -59,6 +61,7 @@ paclist: $(srcdir)/paclist.in
paclog-pkglist: $(srcdir)/paclog-pkglist.in
pacscripts: $(srcdir)/pacscripts.in
pacsearch: $(srcdir)/pacsearch.in
+pacsysclean: $(srcdir)/pacsysclean.in
pactree: $(srcdir)/pactree.in
zsh_completion: $(srcdir)/zsh_completion.in

diff --git a/contrib/pacsysclean.in b/contrib/pacsysclean.in
new file mode 100755
index 0000000..c87082e
--- /dev/null
+++ b/contrib/pacsysclean.in
@@ -0,0 +1,50 @@
+#!/bin/bash
+
+# pacsysclean - Sort installed packages by decreasing installed size. Useful for system clean-up.
+
+PACMAN_OPTS=
+
+usage() {
+ echo "pacsysclean - Sort installed packages by decreasing installed size."
+ echo
+ echo "Usage: pacsysclean [options]"
+ echo
+ echo "Options:"
+ echo " -o <options> Specify custom pacman query options (e.g., dt)"
+ echo " -h, --help Show this help message and exit"
+}
+
+
+if [ -n "$1" ]; then
+ case "$1" in
+ -o) PACMAN_OPTS="${2}" ;;
+ -h|--help) usage; exit 0 ;;
+ *) usage; exit 1 ;;
+ esac
+fi
+
+IFS=$'
'
+name="^Name.*: (.*)$"
+size="^Installed Size.*: (.*) KiB$"
+for line in $(LANG=C pacman -Qi $PACMAN_OPTS); do
+ if [[ $line =~ $name ]]; then
+ printf "%s " ${BASH_REMATCH[1]}
+ elif [[ $line =~ $size ]]; then
+ printf "%s
" ${BASH_REMATCH[1]}
+ fi
+done | sort -g -k2 | awk '
+BEGIN {
+ split("KiB MiB GiB TiB PiB EiB ZiB YiB", suffix)
+}
+function format_size(size) {
+ count = 1
+ while (size + 0 > 1024) {
+ size /= 1024
+ count++
+ }
+ sizestr = sprintf("%.2f %s", size, suffix[count])
+ return sizestr
+}
+{
+ printf("%s %s
", format_size($2), $1);
+}'
--
1.7.7.4
 
Old 12-08-2011, 12:20 PM
Eric Bélanger
 
Default pacsysclean: Add new contrib script

On Mon, Nov 21, 2011 at 5:21 PM, Eric Bélanger <snowmaniscool@gmail.com> wrote:
> pacsysclean sort installed packages by decreasing installed size. It's
> useful for finding large unused package when doing system clean-up. This
> script is an improved version of other similar scripts posted on the
> forums. Thanks goes to Dan for fixing and improving my original script.
>
> Signed-off-by: Eric Bélanger <snowmaniscool@gmail.com>
>
> ---

Bump.

I understand that this script doesn't follow the latest changes to
contrib scripts command line options but could it still be pushed in?
I'll submit a patch to fix the options once the script will be
committed. This way, if there are other widespread changes to contrib
scripts, I won't need to resend the whole script again.

Thanks,
Eric
 

Thread Tools




All times are GMT. The time now is 03:12 PM.

VBulletin, Copyright ©2000 - 2014, Jelsoft Enterprises Ltd.
Content Relevant URLs by vBSEO ©2007, Crawlability, Inc.
Copyright ©2007 - 2008, www.linux-archive.org